#include <stdio.h>
#include <time.h>
#include <sys/mman.h>

int main() {
  const int SIZE = 128 * 1024 * 1024;
  const int REP = 1000;
  struct timespec start, stop;
  int * arena = mmap(0, SIZE * sizeof(int), PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1 , 0);
  for (int K = 1; K <= 1024; K *= 2) {
    float time = 0.0;
    for (int j = 0; j < REP; ++j) {
      clock_gettime(CLOCK_PROCESS_CPUTIME_ID, &start);
      for (int i = 0; i < SIZE; i += K) arena[i] += 3;
      clock_gettime(CLOCK_PROCESS_CPUTIME_ID, &stop);
      time += stop.tv_sec - start.tv_sec;
      time += 1e-9 * (stop.tv_nsec - start.tv_nsec);
    }
    printf("%d %.6f\n", K, time / REP);
  }
  munmap(arena, SIZE * sizeof(int));
  return 0;
}
