#include <arpa/inet.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <unistd.h>

const int connection_queue_size = 1;
const int buffer_size = 1 << 10;

int main() {
  int error;
  int listening_socket = socket(AF_INET, SOCK_STREAM, 0);
  if (0) fprintf(stderr,"created socket %d\n",listening_socket);
  struct sockaddr_in address = {
    .sin_family = AF_INET,
    .sin_port = htons(12345),
    .sin_addr = htonl(INADDR_ANY)
  };
  error = bind(listening_socket, (struct sockaddr *) &address, sizeof address);
  if (error != 0) {
    perror("bind");
    return EXIT_FAILURE;
  }
  if (0) fprintf(stderr,"bound socket %d to INADDR_ANY:12345\n",listening_socket);
  error = listen(listening_socket, connection_queue_size);
  if (error != 0) {
    perror("listen");
    return EXIT_FAILURE;
  }
  if (0) fprintf(stderr,"listening on socket %d\n",listening_socket);
  int connected_socket = accept(listening_socket, NULL, NULL);
  if (0) fprintf(stderr,"got connection, socket %d\n",connected_socket);
  close(listening_socket);
  if (0) fprintf(stderr,"closed listening socket %d\n",listening_socket);
  char buffer[buffer_size];
  while (1) {
    ssize_t r = read(connected_socket, buffer, buffer_size);
    if (r == -1) {
      perror("read");
      return EXIT_FAILURE;
    }
    if (r == 0) { // end of file (i.e., connection closed)
      close(connected_socket);
      return EXIT_SUCCESS;
    }
    if (0) fprintf(stderr,"read %d bytes\n",(int)r);
    for (int i = 0; i < r; ++i) {
      if (putchar(buffer[i]) == EOF) return EXIT_FAILURE;
    }
    fflush(stdout);
  }
}
