#define _POSIX_C_SOURCE 200809L
#include <netdb.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <time.h>
#include <unistd.h>

// data

struct peer {
  struct peer * p_next;
  struct timespec p_last_used;
};

// 2

struct addrinfo * get_server_addresses(const char * port) {
  struct addrinfo hints = {
    .ai_flags = AI_PASSIVE,
    .ai_family = AF_UNSPEC,
    .ai_socktype = SOCK_DGRAM,
    .ai_protocol = 0,
    .ai_addrlen = 0,
    .ai_addr = NULL,
    .ai_canonname = NULL,
    .ai_next = NULL
  };
  struct addrinfo * candidates;
  int error_code = getaddrinfo(NULL, port, &hints, &candidates);
  if (error_code) {
    fprintf(stderr, "getaddrinfo: %s\n", gai_strerror(error_code));
    exit(EXIT_FAILURE);
  }
  return candidates;
}

// 1

int start_listening(const char * port) {
  struct addrinfo * candidates = get_server_addresses(port);
  int s;
  struct addrinfo * p;
  for (p = candidates; p != NULL; p = p->ai_next) {
    s = socket(p->ai_family, p->ai_socktype, p->ai_protocol);
    if (s == -1) continue;
    if (!bind(s, p->ai_addr, p->ai_addrlen)) break;
    close(s);
  }
  if (p == NULL) exit(EXIT_FAILURE);
  freeaddrinfo(candidates);
  return s;
}

// 0

int main(int argc, char * argv[]) {
  if (argc != 2) {
    fprintf(stderr, "usage: %s port\n", argv[0]);
    return EXIT_FAILURE;
  }
  int listening_socket = start_listening(argv[1]);
  struct peer * first_peer = NULL;
  while (1) {
  }
}
